var is_panel_select = false;
var is_resize_select = false;
var is_real_popup = false;

var original_mouse_x = 0;
var original_mouse_y = 0;
var target_original_x = 0;
var target_original_y = 0;
var target_original_width = 0;
var target_original_height = 0;

var current_label_tab = "label_note_1";
var current_label_id = 0;
var current_textbox_tab = null;

var last_label_tab = null;//
var last_label_id = -1;//

var last_note_title = null;
var last_note_value = null;//

var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
var cometmarks = Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension);
	
// temp notes data for notes label
var temp_notes_data = new Array();

// deal with all notes derectly in local_notes_data
var local_notes_data = new Array();

function cometmarks_show_note_panel()
{
	var notes_dialog_width;
	var notes_dialog_height;
	var notes_dialog_x;
	var notes_dialog_y;
	
	if ( document.getElementById("cometmarks_show_note_menuitem").getAttribute("disabled") == "true" )
	 return;

	var panel = document.getElementById("cometmarks_note_panel");
	if ( panel.state == "open" )// has opened
	{
		cometmarks_note_panel_doclose(true);
		return;
	}
	
	// close note panel
	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.notifyObservers(null, "cometmarks-notes-state", "close");
	
	// get last position
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = ps.getBranch("cometmarks.");
	notes_dialog_x = prefs.getIntPref("notes_dialog.x");
	notes_dialog_y = prefs.getIntPref("notes_dialog.y");
	notes_dialog_width = prefs.getIntPref("notes_dialog.width");
	notes_dialog_height = prefs.getIntPref("notes_dialog.height");
			
	if ( notes_dialog_x == 0 && notes_dialog_y == 0 )// original value
	{
		notes_dialog_x = ( window.screen.width - notes_dialog_width ) / 2;
		notes_dialog_y = ( window.screen.height - notes_dialog_height ) / 2;
	}
	
	// load notes data to local_notes_data
	// update local_notes_data 
	cometmarks_get_local_notes();
	
	// open panel
	is_real_popup = true;
	
	panel.openPopupAtScreen(notes_dialog_x, notes_dialog_y, false);
	panel.sizeTo(notes_dialog_width, notes_dialog_height);
	
	document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("disabled", "true");
	document.getElementById("cometmarks_showstatusicon_status").setAttribute("disabled", "true");
}

function cometmarks_note_panel_popup()
{	
	if ( !is_real_popup )
		return;
	is_real_popup = false;
	
	// clear old data 
	while ( temp_notes_data.length > 0 )
		temp_notes_data.shift();	
		
	// load notes data from local_notes_data
	var tab_data = new Object();
	tab_data.label_id = "label_note_1";
	tab_data.guid = local_notes_data[0].guid;
	tab_data.type = local_notes_data[0].type;
	tab_data.title = local_notes_data[0].title;
	tab_data.value = local_notes_data[0].value;
	temp_notes_data.push(tab_data);
	
	// set check state

	// open label	
	cometmarks_note_select_tab(null, current_label_tab);
	is_real_close = false;

	// toolbarbutton
	var note_button = document.getElementById("cometmarks_button_note");
	note_button.setAttribute( "checked", "true" );
	
	// status bar	
	var note_statebar = document.getElementById("cometmarks_show_note_statebar");
	note_statebar.setAttribute( "checked", "true" );
	
	// menu
	var note_menu = document.getElementById("cometmarks_show_note_menuitem");
	note_menu.setAttribute( "checked", "true" );
}

function cometmarks_note_panel_close(event)
{
	if ( event.button != 0 )// not left button
		return;
	
	cometmarks_note_panel_doclose(true);
}

function cometmarks_note_panel_doclose(is_real_close)
{	
	if ( !is_real_close )
	{		
		// save size and position
		var panel = document.getElementById("cometmarks_note_panel");
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		prefs.setIntPref( "notes_dialog.x", panel.boxObject.screenX );
		prefs.setIntPref( "notes_dialog.y", panel.boxObject.screenY );
		prefs.setIntPref("notes_dialog.width", panel.boxObject.width);
		prefs.setIntPref("notes_dialog.height", panel.boxObject.height);
		
		// save temp note data
		for ( var i=0; i<local_notes_data.length; i++ )
		{
			if ( temp_notes_data[current_label_id].guid == local_notes_data[i].guid )
			{
				local_notes_data[i].type = temp_notes_data[current_label_id].type;
				local_notes_data[i].title = temp_notes_data[current_label_id].title;
				local_notes_data[i].value = document.getElementById("panel_note_text").value;
				break;
			}
		}
		panel.sizeTo(10, 10);
		panel.hidePopup();
		
		document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("disabled", "false");
		document.getElementById("cometmarks_showstatusicon_status").setAttribute("disabled", "false");	
		return;
	}
	
	// save all notes to xml file
	if ( document.getElementById("panel_note_text").value != temp_notes_data[current_label_id].value )
	{
		var note_data = new Object();
		note_data.guid = temp_notes_data[current_label_id].guid;
		note_data.type = temp_notes_data[current_label_id].type;
		note_data.title = temp_notes_data[current_label_id].title;
		note_data.value = document.getElementById("panel_note_text").value;
		
		// save and notify
		cometmarks_set_local_notes( note_data );
	}
		
	// remove check state
	var note_button = document.getElementById("cometmarks_button_note");
	note_button.removeAttribute( "checked" );
	
	var note_statebar = document.getElementById("cometmarks_show_note_statebar");
	note_statebar.removeAttribute( "checked" );
	
	var note_menu = document.getElementById("cometmarks_show_note_menuitem");
	note_menu.removeAttribute( "checked" );
	
	// save size and position
	var panel = document.getElementById("cometmarks_note_panel");
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = ps.getBranch("cometmarks.");
	prefs.setIntPref( "notes_dialog.x", panel.boxObject.screenX );
	prefs.setIntPref( "notes_dialog.y", panel.boxObject.screenY );
	prefs.setIntPref("notes_dialog.width", panel.boxObject.width);
	prefs.setIntPref("notes_dialog.height", panel.boxObject.height);
	
	panel.sizeTo(10, 10);
	panel.hidePopup();
	document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("disabled", "false");
	document.getElementById("cometmarks_showstatusicon_status").setAttribute("disabled", "false");
}

// about panel move
function cometmarks_panel_mouseDown(event)
{
	if ( event.button != 0 )// not left button
		return;
		
	if ( event.target.id == "note_close_image" )// close note
	{
		// change close picture
		document.getElementById("note_close_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_close_mousein.png" );
		return;
	}
	
	if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
	{
		// change cut picture
		document.getElementById("note_cut_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_cut_mousein.png" );
		return;
	}
	
	if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
	{
		// change copy picture
		document.getElementById("note_copy_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_copy_mousein.png" );
		return;
	}
	
	if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
	{
		// change paste picture
		document.getElementById("note_paste_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_paste_mousein.png" );
		return;
	}
	
	if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
	{
		// change save picture
		document.getElementById("note_save_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_save_mousein.png" );
		return;
	}
	
	var panel = document.getElementById("cometmarks_note_panel");
	if ( event.target.id == "note_bottom_right_image" )// change note size
	{
		is_resize_select = true;
		original_mouse_x = event.screenX;
		original_mouse_y = event.screenY;
		target_original_width = panel.boxObject.width;
		target_original_height = panel.boxObject.height;
		return;
	}
	
	if ( event.target.getAttribute( "movable" ) != "1" )
		return;
	
	is_panel_select = true;
		
	// save current position	
	original_mouse_x = event.screenX;
	original_mouse_y = event.screenY;

	target_original_x = panel.boxObject.screenX + window.screen.availLeft;
	target_original_y = panel.boxObject.screenY + window.screen.availTop;
}

function cometmarks_panel_mouseMove(event)
{
	if ( event.target.id == "note_close_image" )
	{
		// change close picture
		document.getElementById("note_close_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_close_mouseover.png" );
		document.getElementById("note_close_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.close");
		return;
	}
	
	if ( event.target.id == "note_cut_image" )// cut note
	{
		document.getElementById("note_cut_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.cut");
		
		// change cut picture
		if ( event.target.getAttribute("usable")== "1" )
			document.getElementById("note_cut_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_cut_mouseover.png" );
		
		return;
	}
	
	if ( event.target.id == "note_copy_image"  )// copy note
	{
		document.getElementById("note_copy_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.copy");
		
		// change copy picture
		if ( event.target.getAttribute("usable")== "1" )
			document.getElementById("note_copy_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_copy_mouseover.png" );
		
		return;
	}
	
	if ( event.target.id == "note_paste_image" )// paste note
	{
		document.getElementById("note_paste_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.paste");
		
		// change paste picture
		if ( event.target.getAttribute("usable")== "1" )
			document.getElementById("note_paste_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_paste_mouseover.png" );
		
		return;
	}
	
	if ( event.target.id == "note_save_image" )// save note
	{
		document.getElementById("note_save_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.save");
		
		// change save picture
		if ( event.target.getAttribute("usable")== "1" )
			document.getElementById("note_save_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_save_mouseover.png" );
		
		return;
	}
	
	if ( event.target.id == "note_bottom_right_image" )// change resize curor
	{
		event.target.setAttribute( "style", "cursor: nwse-resize;" );
	}
	
	if ( is_resize_select )
	{
		var deltaX = event.screenX - original_mouse_x;
		var deltaY = event.screenY - original_mouse_y;
		var panel = document.getElementById("cometmarks_note_panel");
		panel.sizeTo( target_original_width + deltaX,  target_original_height + deltaY );
		return;
	}
	
	if ( !is_panel_select )
		return;

	var del_x = event.screenX - original_mouse_x;
	var del_y = event.screenY - original_mouse_y;
	
	var dx = event.screenX - event.clientX;
	var dy = event.screenY - event.clientY;
	
	var panel = document.getElementById("cometmarks_note_panel");
	panel.moveTo( target_original_x + dx + del_x, target_original_y + dy + del_y );
}

function cometmarks_panel_mouseUp(event)
{
	if ( event.button != 0 )// not left button
		return;
		
	if ( event.target.id == "note_close_image" )
	{
		// change close picture
		document.getElementById("note_close_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_close_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
	{
		// change cut picture
		document.getElementById("note_cut_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_cut_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
	{
		// change copy picture
		document.getElementById("note_copy_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_copy_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
	{
		// change paste picture
		document.getElementById("note_paste_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_paste_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
	{
		// change save picture
		document.getElementById("note_save_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_save_mouseout.png" );
		return;
	}
	
	if ( is_resize_select )
	{
		is_resize_select = false;
		return;
	}
	
	if ( !is_panel_select )
		return;

	is_panel_select = false;

	var del_x = event.screenX - original_mouse_x;
	var del_y = event.screenY - original_mouse_y;
	
	if ( del_x == 0 && del_y == 0 ) // not move
		return;
	
	// only call panel.hidePopup();
	cometmarks_note_panel_doclose(false); 
	
	var panel = document.getElementById("cometmarks_note_panel");
	var screenx = target_original_x + del_x - window.screen.availLeft;
	if ( screenx + panel.boxObject.width > window.screen.availWidth -window.screen.availLeft - 3 )
	{
		screenx = window.screen.availWidth - panel.boxObject.width - window.screen.availLeft - 3;
	}

	var screeny = target_original_y + del_y - window.screen.availTop;
	if ( screeny + panel.boxObject.height > window.screen.availHeight -window.screen.availTop - 3 )
	{
		screeny = window.screen.availHeight - panel.boxObject.height - window.screen.availTop - 3;
	}
		
	is_real_popup = true;
	document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("disabled", "true");
	document.getElementById("cometmarks_showstatusicon_status").setAttribute("disabled", "true");
	
	panel.openPopupAtScreen(screenx, screeny, false);
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = ps.getBranch("cometmarks.");
	panel.sizeTo(prefs.getIntPref("notes_dialog.width"), prefs.getIntPref("notes_dialog.height"));
}

function cometmarks_panel_mouseOut(event)
{
	if ( event.target.id == "note_close_image" )
	{
		// change close picture
		document.getElementById("note_close_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_close_mouseout.png" );
	}
	
	if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
	{
		// change cut picture
		document.getElementById("note_cut_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_cut_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
	{
		// change copy picture
		document.getElementById("note_copy_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_copy_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
	{
		// change paste picture
		document.getElementById("note_paste_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_paste_mouseout.png" );
		return;
	}
	
	if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
	{
		// change save picture
		document.getElementById("note_save_image").setAttribute( "src", "chrome://cometmarks/skin/buttons/note_save_mouseout.png" );
		return;
	}
}

function cometmarks_note_select_tab(event, id)
{			
	if ( event == null )
	{
		current_label_tab = id;
	}
	else
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.detail > 1 )// db-click
			return;
			
		if ( current_label_tab ==  event.target.id )
			return;
			
		current_label_tab =  event.target.id;
	}
	
	current_label_id = 0;
	if ( current_label_tab == "label_note_1" )
	{		
		// set note content and title
		if ( temp_notes_data[current_label_id].value.length > 0 )
			document.getElementById("panel_note_text").value = temp_notes_data[current_label_id].value;		
		else
		{
			var now_time_str = new Date();
			document.getElementById("panel_note_text").value = format_GMT_time( now_time_str ) + "\n";	
			temp_notes_data[current_label_id].value = format_GMT_time( now_time_str ) + "\n";	
		}
		
		if ( temp_notes_data[current_label_id].title.length > 0 )
		{
			document.getElementById("label_note_1").value = temp_notes_data[current_label_id].title;
		}
		else
		{
			document.getElementById("label_note_1").value = "Note";
			temp_notes_data[current_label_id].title = "Note";
		}
			
		// set font 
		document.getElementById("label_note_1").setAttribute( "style", "font-weight: bold; text-align:center;" );
		document.getElementById("label_note_2").setAttribute( "style", "font-weight: normal; text-align:center;" );
		document.getElementById("label_note_3").setAttribute( "style", "font-weight: normal; text-align:center;" );
		
		// set background
		document.getElementById("note_bg_left1").setAttribute( "src", "chrome://cometmarks/skin/buttons/notes-label-bg-left.png" );
		document.getElementById("label_note_div1_1").setAttribute( "style", "background-image: url('chrome://cometmarks/skin/buttons/notes-label-bg-center.png')" );
		document.getElementById("note_bg_right1").setAttribute( "src", "chrome://cometmarks/skin/buttons/notes-label-bg-right.png");
		document.getElementById("note_bg_right1").setAttribute( "hidden", "false" );
		
		document.getElementById("note_bg_left2").setAttribute( "hidden", "true" );
		document.getElementById("label_note_div2_1").setAttribute( "style", "url('background-image:chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
		document.getElementById("note_bg_right2").setAttribute( "hidden", "true" );
		
		document.getElementById("note_bg_left3").setAttribute( "hidden", "false" );
		document.getElementById("note_bg_left3").setAttribute( "src", "chrome://cometmarks/skin/buttons/notes-label-bg-left-replace.png" );
		document.getElementById("label_note_div3_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
		document.getElementById("note_bg_right3").setAttribute( "src", "chrome://cometmarks/skin/buttons/notes-label-bg-left-replace.png" );
		
		// set div position
		document.getElementById("label_note_div1").setAttribute( "style", "margin-top: -6px;" );
		document.getElementById("label_note_div2").setAttribute( "style", "margin-top: -5px;" );
		document.getElementById("label_note_div3").setAttribute( "style", "margin-top: -5px;" );
		
		document.getElementById("panel_note_text").focus();
	}
}

function cometmarks_note_edit_tab(event)// db click
{
	if ( event.button != 0 )// not left button
		return;
			
	// show note-textbox
	if ( event.target.id == "label_note_1" )
	{
		var note_label_1 = document.getElementById("label_note_1");
		note_label_1.setAttribute( "hidden", "true" );

		document.getElementById("label_note_div1_11").setAttribute( "style", "margin-top: -4px;" );
		var note_box = document.getElementById("textbox_note_1");
		note_box.setAttribute( "hidden", "false" );
		note_box.setAttribute( "style", " -moz-appearance: none; border: none; text-align:center; color:black; background-color:transparent;" );
		note_box.value = temp_notes_data[current_label_id].title;
		last_note_title = temp_notes_data[current_label_id].title;
		note_box.select();
					
		current_textbox_tab = "textbox_note_1";
	}
}

function cometmarks_save_note_title()
{
	// hidden note-textbox
	var note_box = document.getElementById(current_textbox_tab);
	note_box.setAttribute( "hidden", "true" );
		
	// show note-label
	document.getElementById("label_note_div1_11").setAttribute( "style", "margin-top: 0px;" );
	document.getElementById(current_label_tab).setAttribute( "value", note_box.value );
	document.getElementById(current_label_tab).setAttribute( "hidden", "false" );
	document.getElementById(current_label_tab).setAttribute( "style", "font-weight: bold; text-align:center;" );
	
	if ( last_note_title == note_box.value )
		return;
		
	// save note title 
	temp_notes_data[current_label_id].title = note_box.value;
	
	var note_data = new Object();
	note_data.guid = temp_notes_data[current_label_id].guid;
	note_data.type = temp_notes_data[current_label_id].type;
	note_data.title = temp_notes_data[current_label_id].title;
	note_data.value = document.getElementById("panel_note_text").value;
	
	// save and notify
	cometmarks_set_local_notes( note_data );
}

// get local notes data loaded into local_notes_data array
function cometmarks_get_local_notes()
{  
	// clear old data 
	while ( local_notes_data.length > 0 )
		local_notes_data.shift();	
		
	// get local notes data
	var cometmarks_notes = cometmarks.GetCometMarksLocalNote();
	var local_notes = {};
	cometmarks_notes.GetLocalNotes( local_notes );
	var note_str = local_notes.value;

  if ( note_str.length < 1 ) 
  {
  	// add three empty note data
		var note_count = local_notes_data.length;
		while ( note_count < 1 )
		{
			var empty_note_data = new Object();
			empty_note_data.guid = cometmarks_create_guid();
			empty_note_data.type = "note";
			empty_note_data.title = "Note";
			var now_time_str = new Date();
			empty_note_data.value = format_GMT_time( now_time_str ) + "\n";
			local_notes_data.push(empty_note_data);
			note_count++;
		}	
		return;
  }

  // anlyze note: convert str to dom struct
  var parser = new DOMParser();
  var doc = parser.parseFromString( note_str, "text/xml");
     
  var noteset = doc.getElementsByTagName("noteset");
  var note_list = noteset[0].childNodes;
  for (var i=0; i<note_list.length; i++)
  {
    if ( note_list[i].nodeType == Node.ELEMENT_NODE)
    {
      var note_info = note_list[i].childNodes;
      var note_data = new Object();
         
      for (var j=0; j<note_info.length; j++)
      {
        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
        {
					note_data.guid = note_info[j].textContent;
        }

        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
        {
					note_data.type = note_info[j].textContent;
        }
        
        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
        {
					note_data.title = note_info[j].textContent;
        }

        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
        {
					note_data.value = note_info[j].textContent;
        }
      }

      local_notes_data.push( note_data );// save notes
    }
  }
  
  // deal with loacl_notes_data array
	var note_count = local_notes_data.length;
	while ( note_count < 1 )// notes number less 3
	{
		var empty_note_data = new Object();
		empty_note_data.guid = cometmarks_create_guid();
		empty_note_data.type = "note";
		empty_note_data.title = "CometMarks Note";
		var now_time_str = new Date();
		empty_note_data.value = format_GMT_time( now_time_str ) + "\n";
		local_notes_data.push(empty_note_data);
		note_count++;
	}
	
	local_notes_data.reverse();
}

function cometmarks_set_local_notes( note_data )
{
	// check is new or old
	var is_new_note = true;
	var is_need_commit = false;
	
	// note_content max length 1024
	var note_content = note_data.value;
	if ( note_content.length > 10 * 1024 )
		note_content = note_content.substr(0, 10 * 1024);
		
	for ( var i=0; i<local_notes_data.length; i++ )
	{
		if ( note_data.guid == local_notes_data[i].guid )
		{
		  if ( local_notes_data[i].type != note_data.type )
		  {
		  	local_notes_data[i].type = note_data.type;
		  	is_need_commit = true;
		  }
		
		  if ( local_notes_data[i].title != note_data.title )
		  {
		  	local_notes_data[i].title = note_data.title;
		  	is_need_commit = true;
		  }
		  
		  if ( local_notes_data[i].value != note_content )
		  {
		  	local_notes_data[i].value = note_content;
		  	is_need_commit = true;
		  }
		  
		  is_new_note = false;
		  break;
		}
	}

	// create xml
	var xmldoc = document.implementation.createDocument("","",null);
	var head = xmldoc.createProcessingInstruction("xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"");
	xmldoc.appendChild(head);
	var noteset = xmldoc.createElement("noteset");
	
	local_notes_data.reverse();
	for (var i=0; i<local_notes_data.length; i++)
	{
	  var note = create_element_parent(xmldoc, noteset, "note");
	  create_element(xmldoc, note, "guid", local_notes_data[i].guid );
	  create_element(xmldoc, note, "type", local_notes_data[i].type );
	  create_element(xmldoc, note, "name", local_notes_data[i].title );
	  create_element(xmldoc, note, "content", local_notes_data[i].value );
	}
	
	if ( is_new_note )
	{
	  // create new note element
	  var note = create_element_parent(xmldoc, noteset, "note");
	  create_element(xmldoc, note, "guid", note_data.guid );
	  create_element(xmldoc, note, "type", note_data.type );
	  create_element(xmldoc, note, "name", note_data.title );
	  create_element(xmldoc, note, "content", note_content );
	  
	  local_notes_data.push( note_data );
	  is_need_commit = true;
	}
  
	xmldoc.appendChild(noteset);
	local_notes_data.reverse();
  	
	var serializer = new XMLSerializer();
 	var str = serializer.serializeToString(xmldoc);
	
	// set local notes
	var cometmarks_notes = cometmarks.GetCometMarksLocalNote();
	cometmarks_notes.SetLocalNotes( str );
	
	if ( is_need_commit )
		interval_sync_update(null); // commit new note data
}

function cometmarks_update_notes()
{	
	var panel = document.getElementById("cometmarks_note_panel");
	if ( panel.state != "open" )// not opened
		return;
	
	var server_note_data = null;
	var server_note_title = null;
	for ( var i=0; i<local_notes_data.length; i++ )
	{
		if ( temp_notes_data[current_label_id].guid == local_notes_data[i].guid )
		{	
			server_note_data = local_notes_data[i].value;
			server_note_title = local_notes_data[i].title;
			break;
		}
	}
	
	// not find the note
	if ( i == local_notes_data.length )
	{
		document.getElementById("panel_note_text").value = local_notes_data[0].value;
		document.getElementById("label_note_1").value = local_notes_data[0].value;
		
		temp_notes_data[current_label_id].value = local_notes_data[0].value;
		temp_notes_data[current_label_id].type = local_notes_data[0].type;
		temp_notes_data[current_label_id].type = local_notes_data[0].type;
		temp_notes_data[current_label_id].guid = local_notes_data[0].guid;
		
		return;
	}
	
	// update note title
	if ( temp_notes_data[current_label_id].title != server_note_title )
	{
		document.getElementById("label_note_1").value = server_note_title;
		temp_notes_data[current_label_id].title = server_note_title;
	}
	
	// update note content
	if ( temp_notes_data[current_label_id].value == document.getElementById("panel_note_text").value )// content not edit
	{
		if ( temp_notes_data[current_label_id].value != server_note_data )
		{
			document.getElementById("panel_note_text").value = server_note_data;
			temp_notes_data[current_label_id].value = server_note_data;
		}
	}
	else // has edited
	{
		if ( document.getElementById("panel_note_text").value == server_note_data )
			return;
		
		// create a new note
		var new_note_data = new Object();
		new_note_data.guid = cometmarks_create_guid();
		new_note_data.type = "note";
		new_note_data.title = temp_notes_data[current_label_id].title;
		new_note_data.value = document.getElementById("panel_note_text").value;
		
		// save new note
		temp_notes_data[current_label_id].guid = new_note_data.guid;
		temp_notes_data[current_label_id].type = new_note_data.type;
		temp_notes_data[current_label_id].title = new_note_data.title;
		temp_notes_data[current_label_id].value = new_note_data.value;

		cometmarks_set_local_notes( new_note_data );
	}
}

function cometmarks_note_cut(event)
{
	if ( event.button != 0 )// not left button
		return;
		
	if ( event.target.getAttribute("usable") != "1" )
		return;
		
	var aCommand = "cmd_cut";
	goDoCommand( aCommand );
	
	var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
	if( controller && controller.isCommandEnabled( aCommand ) ) 
	{
		document.getElementById("note_cut_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_cut_mouseout.png" );
		document.getElementById("note_cut_image").setAttribute("usable", "1" );
	}
	else
	{
		document.getElementById("note_cut_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_cut_disabled.png" );
		document.getElementById("note_cut_image").setAttribute("usable", "0" );
	}
}

function cometmarks_note_copy(event)
{
	if ( event.button != 0 )// not left button
		return;
		
	if ( event.target.getAttribute("usable") != "1" )
		return;
		
	var aCommand = "cmd_copy";
	goDoCommand( aCommand );
	
	var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
	if( controller && controller.isCommandEnabled( aCommand ) ) 
	{
		document.getElementById("note_copy_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_copy_mouseout.png" );
		document.getElementById("note_copy_image").setAttribute("usable", "1" );
	}
	else
	{
		document.getElementById("note_copy_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_copy_disabled.png" );
		document.getElementById("note_copy_image").setAttribute("usable", "0" );
	}
}

function cometmarks_note_paste(event)
{
	if ( event.button != 0 )// not left button
		return;
		
	if ( event.target.getAttribute("usable") != "1" )
		return;
		
	var aCommand = "cmd_paste";
	goDoCommand( aCommand );
	
	var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
	if( controller && controller.isCommandEnabled( aCommand ) ) 
	{
		document.getElementById("note_paste_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_paste_mouseout.png" );
		document.getElementById("note_paste_image").setAttribute("usable", "1" );
	}
	else
	{
		document.getElementById("note_paste_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_paste_disabled.png" );
		document.getElementById("note_paste_image").setAttribute("usable", "0" );
	}
}

function cometmarks_note_save(event)
{	
	if ( event.target.getAttribute("usable") != "1" )
		return;
		
	// save all notes
	temp_notes_data[current_label_id].value = document.getElementById("panel_note_text").value;
	
	var note_data = new Object();
	note_data.guid = temp_notes_data[current_label_id].guid;
	note_data.type = temp_notes_data[current_label_id].type;
	note_data.title = temp_notes_data[current_label_id].title;
	note_data.value = temp_notes_data[current_label_id].value;
	
	// save and notify
	cometmarks_set_local_notes( note_data );
	
	document.getElementById("note_save_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_save_disabled.png" );		
	document.getElementById("note_save_image").setAttribute("usable", "0" );
}

var cometmarks_update_command = 
{
	update_cut: function()
	{
		var aCommand = "cmd_cut";	
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_cut_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_cut_mouseout.png" );		
			document.getElementById("note_cut_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_cut_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_cut_disabled.png" );
			document.getElementById("note_cut_image").setAttribute("usable", "0" );
		}
	},

	update_copy: function()
	{			
		var aCommand = "cmd_copy";
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_copy_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_copy_mouseout.png" );
			document.getElementById("note_copy_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_copy_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_copy_disabled.png" );
			document.getElementById("note_copy_image").setAttribute("usable", "0" );
		}
	},
	
	update_paste: function()
	{
		var aCommand = "cmd_paste";
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_paste_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_paste_mouseout.png" );
			document.getElementById("note_paste_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_paste_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_paste_disabled.png" );
			document.getElementById("note_paste_image").setAttribute("usable", "0" );
		}
	}
};

var cometmarks_notetext = 
{
	input: function( event )
	{
		if ( event.target.id != "panel_note_text" )
			return;
	
		document.getElementById("note_save_image").setAttribute("src", "chrome://cometmarks/skin/buttons/note_save_mouseout.png" );		
		document.getElementById("note_save_image").setAttribute("usable", "1" );	
	},
	
	keyup: function( obj )
	{
		var mlength = obj.getAttribute ? parseInt( obj.getAttribute("maxlength") ) : "";
		if ( obj.getAttribute && obj.value.length > mlength)
			obj.value = obj.value.substring( 0, mlength );
	}
};